poj2195&&hdu1533 最小费用流

这题也可以用km做,我写的代码km比费用流快很多。

最小费用流:

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<queue>
#include<stdlib.h>
#define INF 1000000000
using namespace std;
const int maxn = 1100;
struct Set
{
    int x,y;
}mnum[110*110],hnum[110*110];
struct node
{
    int to;
    int v;
    int flag;
    int cost;
    int next;
}edge[maxn*maxn/2];
char map[110][110];
int n,m,cou1,cou2,index,head[maxn],s,t,pre[maxn],fpre[maxn],N,dis[maxn];
int Get(int i,int j)
{
    return abs(mnum[i].x-hnum[j].x)+abs(mnum[i].y-hnum[j].y);
}
void add(int x,int y,int v,int cost)
{
    edge[index].to=y;
    edge[index].v=v;
    edge[index].cost=cost;
    edge[index].flag=index+1;
    edge[index].next=head[x];
    head[x]=index++;
    edge[index].to=x;
    edge[index].v=0;
    edge[index].cost=-cost;
    edge[index].flag=index-1;
    edge[index].next=head[y];
    head[y]=index++;
}
void makemap()
{
    int i,j;
    cou1=cou2=0;
    for(i=0;i<n;i++)
    {
        for(j=0;j<m;j++)
        {
            if(map[i][j]==‘m‘)
            {
                mnum[++cou1].x=i;
                mnum[cou1].y=j;
            }
            else if(map[i][j]==‘H‘)
            {
                hnum[++cou2].x=i;
                hnum[cou2].y=j;
            }
        }
    }
    index=1;
    memset(head,-1,sizeof(head));
    N=cou1+cou2+1;
    s=0;
    t=cou1+cou2+1;
    for(i=1;i<=cou1;i++)
        add(s,i,1,0);
    for(i=1;i<=cou2;i++)
        add(i+cou1,t,1,0);
    for(i=1;i<=cou1;i++)
    {
        for(j=1;j<=cou2;j++)
        {
            add(i,j+cou1,1,Get(i,j));
        }
    }
}
bool spfa(int s,int t)
{
    int vis[maxn];
    queue<int>q;
    memset(pre,-1,sizeof(pre));
    memset(vis,0,sizeof(vis));
    int i;
    for(i=0;i<=N;i++)
        dis[i]=INF;
    vis[s]=1;
    dis[s]=0;
    pre[s]=0;
    q.push(s);
    while(!q.empty())
    {
        int u=q.front();
        q.pop();
        vis[u]=0;
        for(i=head[u];i!=-1;i=edge[i].next)
        {
            if(edge[i].v&&dis[edge[i].to]>dis[u]+edge[i].cost)
            {
                dis[edge[i].to]=dis[u]+edge[i].cost;
                if(!vis[edge[i].to])
                {
                    vis[edge[i].to]=1;
                    q.push(edge[i].to);
                }
                pre[edge[i].to]=u;
                fpre[edge[i].to]=i;
            }
        }
    }
    if(dis[t]>=INF)return false;
    return true;
}
int main()
{
    int i,j;
    while(~scanf("%d%d",&n,&m))
    {
        if(!n&&!m)break;
        for(i=0;i<n;i++)
            scanf("%s",map[i]);
        makemap();
        int ans=0;
        while(spfa(s,t))
        {
            int minflow=INF;
            for(i=t;i!=0;i=pre[i])
            {
                if(minflow>edge[fpre[i]].v)
                    minflow=edge[fpre[i]].v;
            }
            ans+=minflow*dis[t];
            for(i=t;i!=0;i=pre[i])
            {
                edge[fpre[i]].v-=minflow;
                edge[edge[fpre[i]].flag].v+=minflow;
            }
        }
        printf("%d\n",ans);
    }
}

km:

#include<stdio.h>
#include<string.h>
#include<algorithm>
#define INF 99999999
#define maxn 105
using namespace std;
struct node
{
    int x;
    int y;
}h[maxn],m[maxn];
char g[maxn][maxn];
int map[maxn][maxn],pr[maxn],pl[maxn],visr[maxn],visl[maxn],match[maxn],slack[maxn];
int col,row;
void init(int x)
{
    int i,j;
    for(i=0;i<=x;i++)
        for(j=0;j<=x;j++)
            if(i==j)map[i][j]=0;
            else map[i][j]=INF;
}
int dfs(int u,int n)
{
    int i,j;
    visl[u]=1;
    for(i=0;i<n;i++)
    {
        if(!visr[i])
        {
            int val=pl[u]+pr[i]-map[u][i];
            if(val==0)
            {
                visr[i]=1;
                if(match[i]==-1||dfs(match[i],n))
                {
                    match[i]=u;
                    return 1;
                }
            }
            if(val>0&&val<slack[i])
                slack[i]=val;
        }
    }
    return 0;
}
int km(int n)
{
    int i,j;
    memset(pr,0,sizeof(pr));
    memset(match,-1,sizeof(match));
    for(i=0;i<n;i++)
        pl[i]=INF;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
            slack[j]=INF;
        while(1)
        {
            memset(visr,0,sizeof(visr));
            memset(visl,0,sizeof(visl));
            if(dfs(i,n))break;
            int k=INF;
            for(j=0;j<n;j++)
            {
                if(!visr[j]&&slack[j]<k)
                    k=slack[j];
            }
            for(j=0;j<n;j++)
            {
                if(visl[j])
                    pl[j]-=k;
                if(visr[j])
                    pr[j]+=k;
            }
        }
    }
    int res=0;
    for(i=0;i<n;i++)
    {
        res+=map[match[i]][i];
    }
    return res;
}
int main()
{
    int i,j;
    while(scanf("%d%d",&row,&col)!=EOF)
    {
        if(row==0&&col==0)
            break;
        int count1=0,count2=0;
        for(i=0;i<row;i++)
            scanf("%s",g[i]);
        for(i=0;i<row;i++)
            for(j=0;j<col;j++)
            {
                if(g[i][j]==‘H‘)
                {
                    h[count1].x=i;h[count1++].y=j;
                }
                else if(g[i][j]==‘m‘)
                {
                    m[count2].x=i;m[count2++].y=j;
                }
            }
        init(count1);
        for(i=0;i<count1;i++)
            for(j=0;j<count2;j++)
            {
                map[i][j]=-(abs(h[i].x-m[j].x)+abs(h[i].y-m[j].y));
            }
        printf("%d\n",-km(count1));
    }
}
时间: 2024-10-08 02:17:43

poj2195&&hdu1533 最小费用流的相关文章

最小费用流 poj2195

Going Home Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 17955   Accepted: 9145 Description On a grid map there are n little men and n houses. In each unit time, every little man can move one unit step, either horizontally, or vertical

[POJ2195]Going Home(带权最大匹配,KM,最小费用流)

题目链接:http://poj.org/problem?id=2195 题意:给个图,m代表人H代表房子.每一个m要有一个H,代价是曼哈顿距离.问让所有m找到房子的最小花费. 可以直接枚举m和H建二分图跑KM. 1 #include <algorithm> 2 #include <iostream> 3 #include <iomanip> 4 #include <cstring> 5 #include <climits> 6 #include

POJ2195 最小费用流

题目:http://poj.org/problem?id=2195 处理出每个人到每个门的曼哈顿距离,分别建立容量为1费用为曼哈顿距离的边,在源点和每个人人之间建立容量为1费用为0的边,在门和汇点之间建立容量为1费用为0的边,然后跑最小费用流即可. 1 #include<cstdio> 2 #include<cstring> 3 #include<vector> 4 #include<queue> 5 #include<iostream> 6 #

POJ2195 Going Home 【最小费用流】+【二分图最佳匹配】

Going Home Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 18169   Accepted: 9268 Description On a grid map there are n little men and n houses. In each unit time, every little man can move one unit step, either horizontally, or vertical

POJ 2195Going Home(网络流之最小费用流)

题目地址:POJ2195 本人职业生涯费用流第一发!!快邀请赛了,决定还是多学点东西,起码碰到简单的网络流要A掉.以后最大流费用流最小割就一块刷. 以前费用流在我心目中一直是高大上,高不可攀的形象,可这两天才发现,原来费用流就是一个spfa再加点东西...一直以为费用流会比最大流的isap要麻烦好多,毕竟多了一个费用的元素....我真的错了..仔细研究了一下,只用一个spfa确实就可以解决了... 这题是一个入门题(虽然还多了些处理..),建图思路很简单,就是将人与源点相连,流量为1,费用为0,

POJ-2195(最小费用最大流+MCMF算法)

Going Home POJ-2195 这题使用的是最小费用流的模板. 建模的时候我的方法出现错误,导致出现WA,根据网上的建图方法没错. 这里的建图方法是每次到相邻点的最大容量为INF,而花费为1,因为花费等于距离.但是需要增加一个源点和一个汇点,然后将每个人和源点相连,每个房子和汇点相连,容量都为1,费用都为0. #include<iostream> #include<algorithm> #include<cstring> #include<queue>

HDU 3488Tour(网络流之最小费用流)

题目地址:hdu3488 这题跟上题基本差不多啊....详情请戳这里. 另外我觉得有要改变下代码风格了..终于知道了为什么大牛们的代码的变量名都命名的那么长..我决定还是把源点与汇点改成source和sink吧..用s和t太容易冲突了...于是如此简单的一道题调试到了现在..sad... 代码如下: #include <iostream> #include <stdio.h> #include <string.h> #include <stdlib.h> #

【bzoj1834】[ZJOI2010]network 网络扩容 最大流+最小费用流

题目描述 给定一张有向图,每条边都有一个容量C和一个扩容费用W.这里扩容费用是指将容量扩大1所需的费用.求: 1. 在不扩容的情况下,1到N的最大流: 2. 将1到N的最大流增加K所需的最小扩容费用. 输入 输入文件的第一行包含三个整数N,M,K,表示有向图的点数.边数以及所需要增加的流量. 接下来的M行每行包含四个整数u,v,C,W,表示一条从u到v,容量为C,扩容费用为W的边. 输出 输出文件一行包含两个整数,分别表示问题1和问题2的答案. 样例输入 5 8 2 1 2 5 8 2 5 9

poj2135 最小费用流

添加超级源点(与点1之间的边容量为2,权值为0)和超级汇点(与点N之间的边容量为2,权值为0),求流量为2的最小费用流.注意是双向边. #include <iostream> #include <cstdio> #include <vector> #include <queue> using namespace std; const long long INF = 0x3f3f3f3f3f3f3f3f; typedef long long ll; typed